Use case 2: Zakup produktu pakowanego za pomocą karty
=====================

**Aktor podstawowy: Klient**

Główni odbiorcy i oczekiwania względem systemu:
-----------------------------------------------

- Klient: Oczekuje wydania wybranego produktu po danej cenie.

- Właściciel automatu : Oczekuje ze automat nie wyda za dużo produktów.

Warunki wstępne:
----------------

Klient posiada przy sobie kartę płatniczą. W automacie znajduja sie produkty.

Warunki końcowe:
----------------

Klient dokonał zapłaty. Produkt został wydany klientowi.

Scenariusz główny (ścieżka podstawowa):
---------------------------------------

  1. Klient wybiera numer produktu.
  2. System informuje klienta o cenie.
  3. Klient dokonje płatności kartą. 
  4. Automat komunikuje sie z systemem obsługi płatności elektronicznej pobiera pieniądze z karty.
  5. Automat wydaje wybrany produkt.
  6. Klient odbiera wybrany produkt.

Rozszerzenia (ścieżki alternatywne):
------------------------------------

 *a. W dowolnej sytuacji kiedy system zawiesza się:
    Niezbędne jest aby wszystkie kluczowe dane mogły zostać odtworzone w dowolnym momencie ścieżki
    podstawowej.
    1. System wyświetla informację o błędzie, zapisuje błąd i resetuje się
    2. System odtwarza stan przed zawieszeniem się 

 *b. Brak produktu:
    1. System wyświetla informacje o braku produktu.

 2a. Błędny identyfikator produktu:
    1. System sygnalizuje bład i prosi o podanie prawidłowego identyfikatora.

 5a. System nie może dokonać tranzakcji:
    1.System sygnalizuje bład i prosi o powtórzenie procesu płatnosci.

 5b. Klient ma niewystarczająca ilość pieniędzy aby zapłącić za wybrany produkt:
    1. System informuje o braku wystarczającej ilości srodków i przerywa tranzakcję.

 6b. Produkt blokuje sie podczas wydawania:
    1. System sygnalizuje bład i automatycznie wysyła informację o błedzie do techsupportu. 

Wymagania specjalne:
--------------------

  - System posiada informacje o składzie produktu i o alergenach.

  - Możliwość interfejsu wielojęzycznego.

Wymagania technologiczne oraz ograniczenia na wprowadzane dane:
---------------------------------------------------------------

 2a. Panel dotykowy, służący do wyboru produktu i anulowania zakupu.

 4a. Czytnik kart płatniczych.
    1. Autoryzacja musi być dokonana w czasie 10 sekund w 95% przypadków.

 3a. Ekran do wyświatlania ceny i informacji o produkcie, informacje muszą być czytalne z odległości 1m.

Kwestie otwarte:
----------------

  - Obsługa automatu przez osoby niewidome?

  - ...
 
  - ...
